package com.java8.practies;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.function.Function;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.stream.Stream;
public class TestEmployee {

	public static void main(String[] args) {
		
	   List<String> depList = new ArrayList<String>();
	   depList.add("IT");
	   depList.add("CSE");
	   depList.add("ECE");
	   
	   List<String> depList2 = new ArrayList<String>();
	   depList2.add("ECE");
	   depList2.add("EEE");
	   depList2.add("IT");

		List<Employee> listEmp = new ArrayList<Employee>();
		listEmp.add(new Employee("1", "Uma", "vani", depList));
		listEmp.add(new Employee("2", "Sujit", "Krishnan", depList2));
		listEmp.add(new Employee("3", "Brayan", "Braya", depList));
		listEmp.add(new Employee("4", "Allice", "Ali", depList2));
		listEmp.add(new Employee("5", "Sco te","", depList2));
		listEmp.add(new Employee("6", "Rajesh", "Krishnan", depList));
		listEmp.add(new Employee("7", "Ramana", "Raju", depList2));
		listEmp.add(new Employee("8", "Raju", "Krishnan", depList));
		listEmp.add(new Employee("9", "Rishi", "Vani", depList));
		listEmp.add(new Employee("10", "Dattu", "", depList2));
		
		
		//list of employees, get the first employee from the list and return his fullName.

		listEmp.stream().map(emp -> {
			Optional.ofNullable(emp)
			.ifPresent(x -> System.out.println("First Employee Details  :" + x.getFirstName() + x.getLastName()));
			return emp;
		}).findFirst();
		
		
		//Consider a list of employees, sort the employees by their firstName and
		listEmp.stream().sorted(Comparator.comparing(Employee::getFirstName)).collect(Collectors.toList()).forEach(System.out::println);

			
		//Consider a list of employees, return the employee whose empId is highest
		Optional<Employee> e = listEmp.stream().collect(Collectors.maxBy(Comparator.comparing(Employee::getId)));
		if (e.isPresent()) {
			System.out.print("Higest Employee Id"+e.get());
		}
		
		//Consider a list of employees, concat the fullName of all the employees with pipe (|) and return the concatenated string.
		
		String joinedString = listEmp.stream().map(x -> x.firstName + x.lastName).collect(Collectors.joining("|"));
		System.out.println("FullNames Of all employees concat with | symbol is :-----------" + joinedString);
		

		//Consider a list of 10 employees, get the 8th employee and print his full name and department name.
		listEmp.stream().sorted(Comparator.comparing(Employee::getId)).skip(8).limit(1).forEach(System.out::println);

		//consider list of employees and list of employee ids. return the list of employees matching with the given list of employee ids.
		 List<Employee> checkForMatches = new ArrayList<>();
		 checkForMatches.add(new Employee("2", "siri", "raja", depList));
		 checkForMatches.add(new Employee("7", "roja", "rani", depList2));
		 checkForMatches.add(new Employee("11", "roja", "rani", depList));
		 

		 listEmp.stream().filter(employee -> checkForMatches.stream().anyMatch(dept -> employee.getId().equals(dept.getId())))
					.collect(Collectors.toList()).forEach(System.out::println);

		
		//Store ids are of 4 digit strings.if length of given storeId is less than 4 digits,you need to prefix with zeros and return a 4 digit storeId.
		
		 listEmp.stream()
		.map(employee -> {
			Optional.ofNullable(employee)
					.map(Employee::getId)
					.map(id -> String.format("%04d", Integer.parseInt(id)))
					.ifPresent(a -> employee.setId(a));
			return employee.getId();
		}).collect(Collectors.toList()).forEach(System.out::println); 
		 
		 
		//Consider a list of employees, and if a department name is given as argument, list out the employees which doesn't belong to that department.

		 listEmp.stream().filter(x -> !x.getDepartmentNames().stream().equals("EEE"))
					.collect(Collectors.toList()).forEach(System.out::println); 
		 
		//given a list of employees. Can you create a map with the count of employees each department has ?
			//with key as department name and count of employees as value.
		Stream<String> distinctDept=listEmp.stream()
				 .map(Employee::getDepartmentNames)
				  .flatMap(x->x.stream());
		
		Map<String, Long> mapDepartment = distinctDept.collect(Collectors.groupingBy(Function.identity(), Collectors.counting()));
		mapDepartment.forEach((k, v) -> System.out.println((k + ":" + v)));


	}

}
